/*----------------------------------------------------------------------------

     @@@@@@@@gWX^Zp@2012N10   RS485eXgvO
    @@@@@@@@@@PIC16F1827 + RS485 + FT232R + kinect
    @@                                                    by@c@dH
                                                           (DENKO TANAKA)
 
 @@@@@@@@@@@@@-p\R2012N8Kinect_ARsensing̗pO-
 
 *----------------------------------------------------------------------------*/
#include <htc.h>

__CONFIG(FOSC_INTOSC & MCLRE_ON & BOREN_ON & WDTE_OFF & CP_ON);
#define _XTAL_FREQ 32000000

//                  PIC16F1827
/*               +-------u-------+                 */
/*    Driver2 <->|RA2/AD2     RA1|--> Driver1      */
/*  Sense I/O <--|RA3     RA0/AD0|<-> Sense AD     */
/*       (nc) <--|RA4         RA7|--> (nc)         */
/*      MCLR# -->|RA5         RA6|--> (nc)         */
/*            ===|VSS         VDD|===              */
/*   485 DERE <--|RB0         RB7|<-> ICSPDAT      */
/*     485 RX -->|RB1         RB6|--> ICSPCLK      */
/*     485 TX <--|RB2         RB5|--> (nc)         */
/*       (nc) <--|RB3         RB4|--> (nc)         */
/*               +---------------+                 */

const unsigned char ACODE[16] ={'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'};
unsigned char GetData[128];
unsigned char GetNo, GetFlag;

//********************I/O|[g֐**********************************
void PIC_Init(void)
{
	//NbN̐ݒ
	OSCCON = 0xF0;	// 0b11110000 internal 8x4=32MHz
	//IvVWX^̐ݒ
	OPTION_REG = 0x7FFF;//0b01111111 #WPUEN=0
	//荞݊֌W̐ݒ
	INTCON = 0x00;//0b00000000
	PIE1   = 0x00;//0b00000000
	PIE2   = 0x00;//0b00000000
	PIE3   = 0x00;//0b00000000
	PIE4   = 0x00;//0b00000000
	PIR1   = 0x00;//0b00000000
	PIR2   = 0x00;//0b00000000
	PIR3   = 0x00;//0b00000000
	PIR4   = 0x00;//0b00000000
	IOCBP  = 0x00;//0b00000000
	IOCBN  = 0x00;//0b00000000
	IOCBF  = 0x00;//0b00000000
	//|[g̑փsݒ
	APFCON0 = 0x00;//0b00000000 RX = RB1
	APFCON1 = 0x00;//0b00000000 TX = RB2
	//|[gA̐ݒ
	PORTA  = 0x00;//0b00000000
	TRISA  = 0x20;//0b00100000
	ANSELA = 0x00;//0b00000000
	//|[gB̐ݒ
	PORTB  = 0x00;//0b00000000
	TRISB  = 0x02;//0b00000010
	WPUB   = 0xFF;//0b11111111
	ANSELB = 0x00;//0b00000000
}

//********************************VA|[g֐***********************************
void COM_Init(void)
{
	BAUDCON = 0x40;//0b010000000
	SPBRGH  = 0x00;//0b00000000
	SPBRG   = 0x10;//16(115200bps at 32MHz Hi)
	//SPBRG   = 0xCF;//207(9600bps at 32MHz Hi)
	TXSTA   = 0x26;//0b00100110 BRGH = hi
	RCSTA   = 0x90;//0b10010000
}

void putc(unsigned char sdata)
{
	while((PIR1 & 0x10) == 0){ }//0b00010000 TXIF
	TXREG = sdata;
}

unsigned char getc(void)
{
	while((PIR1 & 0x20) == 0){ }//0b00100000 RCIF
	return(RCREG);
}

//*******************************݊֐@**********************************
void INTRPT_Init(void)
{
	//M荞݃Cl[u
	PIE1bits.RCIE = 1;
	//MtONA
	if(PIR1bits.RCIF != 0) getc();//_~[[h
	//ԕω荞݃Cl[uCӊ荞݃Cl[uCO[o荞݃Cl[u
	INTCON = 0xC0;//0b11000000
}

//*********************************荞ݏ@s֐ *************************
//荞݂̓Cl[urbgƃtOrbĝQ̃rbgŔf
static void interrupt intrps(void)
{
	//VAM荞
	if(PIR1bits.RCIF != 0)
	{
		GetData[GetNo] = RCREG;
		if(GetData[GetNo] == 0x0A) GetFlag = 1;//LF
		GetNo++;
		GetNo &= 0x7F;
	}
}

//***********************************ADC֐***********************************
void ADC_Init(void)
{
	ADCON1   = 0xA0;//0b10100000 right,Fosc/32(1us)
	ADCON0   = 0x01;//0b00000001 ADC ON
}

unsigned short Position_Read(void)
{	PORTAbits.RA0 = 0;//Clear Charge
	PORTAbits.RA1 = 0;
	PORTAbits.RA2 = 0;
	PORTAbits.RA3 = 0;
	__delay_us(5);
	PORTAbits.RA1 = 1;//Driver1 Hi
	TRISA  = 0x29;//0b00101001 RA3 HiZ@Y|[g͂ɕύX
	ANSELA = 0x01;//0b00000001 RA0 AD0@Y|[gADɕύX
	ADCON0 = 0x01;//AD STOP
	__delay_us(10);
	ADCON0  |= 0x02;//0b00000010 ADC ch0 START
	while((ADCON0 & 0x02) != 0) {} //0b00000010
	PORTA  = 0x00;//0b00000000@|[g̐ݒݒɖ߂
	TRISA  = 0x20;//0b00100000
	ANSELA = 0x00;//0b00000000
	return(((unsigned short)(ADRESH & 0x03) << 8) | ADRESL);
}

unsigned short Pressure_Read(void)
{	unsigned short V1,V2;
	PORTAbits.RA1 = 1;//Driver1 Hi
	PORTAbits.RA3 = 0;//Sense I/O Lo
	TRISA  = 0x25;//0b00100101@Y|[gAD͂ɕύX
	ANSELA = 0x05;//0b00000101 RA0 RA2 AD0
	ADCON0 = 0x01;//AD STOP
	__delay_us(10);
	ADCON0  |= 0x02;//0b00000010 ADC ch0 START
	while((ADCON0 & 0x02) != 0) {} //0b00000010
	V2 = ((unsigned short)(ADRESH & 0x03) << 8) | ADRESL;
	ADCON0 = 0x09;//0b00001001 AD STOP & ch2
	__delay_us(5);
	ADCON0 |= 0x02;//0b00000010 ADC ch2 START
	while((ADCON0 & 0x02) != 0) {} //0b00000010
	V1 = ((unsigned short)(ADRESH & 0x03) << 8) | ADRESL;
	PORTA  = 0x00;//0b00000000@|[g̐ݒݒɖ߂
	TRISA  = 0x20;//0b00100000
	ANSELA = 0x00;//0b00000000
	return(((V2 << 6) / (V1 - V2));//Lmۂ̂߂V2Vtg
}

//********************************C֐**************************************:
void main(void)
{
	unsigned long adata;
	PIC_Init();
	COM_Init();
	ADC_Init();
	PORTBbits.RB0 = 0;//485DERE# = 0
	//ۂ̏
	__delay_ms(500);
	GetFlag = 0;
	GetNo = 0;
	INTRPT_Init();
	while(1)
	{
		if(RCSTAbits.FERR != 0)
		{	adata = RCREG;//dummy read
		}
		if(RCSTAbits.OERR != 0)
		{	RCSTAbits.CREN = 0;
			RCSTAbits.CREN = 1;
		}
		if(GetFlag == 1)
		{	if(GetData[0] == 'C')
			{	__delay_ms(10);
				PORTBbits.RB0 = 1;//485DERE# = 1
				putc('A'); putc(0x0D); putc(0x0A);
				while(TRMT == 0) {}
				PORTBbits.RB0 = 0;//485DERE# = 0
				GetNo = 0;
				GetFlag = 0;
			}
			if(GetData[0] == 'E')
			{	__delay_ms(10);
				PORTBbits.RB0 = 1;//485DERE# = 1
				putc('A'); putc(0x0D); putc(0x0A);
				while(TRMT == 0) {}
				PORTBbits.RB0 = 0;//485DERE# = 0
				GetNo = 0;
				GetFlag = 0;
			}
			if(GetData[0] == 'P')
			{	__delay_ms(10);
				PORTBbits.RB0 = 1;//485DERE# = 1
				putc('A'); putc(0x0D); putc(0x0A);
				while(TRMT == 0) {}
				PORTBbits.RB0 = 0;//485DERE# = 0
				GetNo = 0;
				GetFlag = 0;
			}
			if(GetData[0] == 'R')
			{
				adata = Pressure_Read();
				if(adata > 0x0010) adata = (unsigned long)Position_Read() << 12;
				else adata = 0;
				PORTBbits.RB0 = 1;//485DERE# = 1
				putc(ACODE[(adata >> 20) & 0x0F]);//6
				putc(ACODE[(adata >> 16) & 0x0F]);//5
				putc(ACODE[(adata >> 12) & 0x0F]);//4
				putc(ACODE[(adata >>  8) & 0x0F]);//3
				putc(ACODE[(adata >>  4) & 0x0F]);//2
				putc(ACODE[adata & 0x0F]);//1
				putc(0x0D);//CR
				putc(0x0A);//LF
				while(TRMT == 0) {}
				PORTBbits.RB0 = 0;//485DERE# = 0
				GetNo = 0;
				GetFlag = 0;
			}
		}
	}
}
